#define BLOCK_SIZE 4096
#define POINTER_SIZE 4
#define INTEGER_SIZE 4
#define MB_4 4194304
#define MB_1 1048576

// MAGIC section...

// Linux specials
#define LINUX_MAGIC_PROCESS1 "kthreadd\0" // process, that should be found in all 2.6 running linuxes. Can be changed by parameter
#define LINUX_MAGIC_PROCESS2 "kthread\0"  // on some system there is only one "d";)
#define LINUX_MAGIC_MODULE "loop\0"// module, that should be found in all 2.6 running linuxes.(if modules are enabled) 
				   // can be changed by parameter
#define LINUX_MAGIC_USER_PROCESS "init\0"

// Virtual Page Table (or PaGe Directory)
#define VPT_MAGIC_ADDR 0x00300000    // where to start looking for VPT
#define VPT_MAGIC_BS 4096          // size of block with VPT
#define VPT_MAGIC_COUNT 2000        // how many page to check, when looking for VPT
#define VPT_MAGIC_ZEROES 3072        // how many zeroes should be at the beggining of VPT

// task_struct
#define TS_MAGIC_HEADLIST_NUMBER 9 //11 //9 //11	//10//distace in list_head occurances between in task_struct comm and tasks  :) 
// XXX find out why exactly XXX !!! does not match according to tas_struct in sched.h !!! investigate XXX XXX specify by parameter
#define TS_MAGIC_HEADLIST_FRONT_NUMBER 5//3	// Because backward search does not work good enough
#define TS_MAGIC_HEADLIST_SPREAD 3	// How far from TS_MAGIC_HEADLIST_FRONT_NUMBER to look for right list_head (both sides,unit: list_heads;)
#define TS_MAGIC_HEADLIST_MAX 20	// Max. how many headlists we expect before comm in task_struct. 
#define TS_MAGIC_MAX_TRIES 300 //200 //160		//how many times try to find "tasks" inside task_struct..can vary!
#define TS_MAGIC_HL_MM_DST 6*POINTER_SIZE	//Distance from "tasks"	list_head to "mm" mmstruct...can vary!
#define TS_MAGIC_FILES_MAX_TRIES 100		//how many times try to find "files" inside task_struct
// mm_struct
#define MM_MAGIC_PGD_DST 9*POINTER_SIZE		//Distance from beginning of mm_struct to pgd variable...can vary!

// module
#define MD_MAGIC_HEADLIST_NUMBER 2
#define MD_MAGIC_HEADLIST_MAX 10	// Max. how many headlists we expect before name in module
#define MD_MAGIC_MAX_TRIES 50 		//how many times try to find "list"inside module..can vary!
#define MD_MAGIC_HL_NAME_DST 6*POINTER_SIZE	//Distance from "list" list_head to "name" in module...can vary!

// qstr struct 
#define QS_MAGIC_MAX_FILENAME_SIZE 512	//max. how long can be filename, when trying to list open files

//dentry struct
#define DT_MAGIC_MAX_TRIES 100	//max. how many try to verify qstr inside dentry struct

//vfs struct
#define VFS_MAGIC_MAX_TRIES 100	//max. how many try to verify devname inside vfs_struct
#define VFS_MAGIC_PATTERN  "/dev/"	//pattern we are looking for when verifying vfs_struct
#define VFS_MAGIC_PATTERN_LEN 5 // length of pattern when verifying vfs_struct

// files_struct
#define FS_MAGIC_MAX_TRIES 100  //max. how many times try to fdt inside files_struct

// fdtable struct
#define FD_MAGIC_MAX_TRIES 100  //max. how many times try to fdt inside files_struct

// file struct
#define FL_MAGIC_MAX_TRIES 100  //max. how many times try to fdt inside files_struct

